class Fdchat
  require 'fdchat/chat'
  require 'fdchat/chat_sala'
  require 'fdchat/chat_sala_allowed'


  attr_accessor  :sala

  def initialize(id: nil, owner: nil,owner_id: nil)
    if owner_id
      @sala = ChatSala.find_by(
          owner_id: BSON::ObjectId.from_string(owner_id)
      )
    else
    @sala = ChatSala.find_by(:$or => [
      { _id: id},
      { owner: owner}
    ])
    end
    unless @sala
     @sala = ChatSala.create!( owner: owner)
     if @sala
      add_participant_sala(owner)
     end
    end
  end
  def all_chats
    @sala.chats.order_by(:created_at => 'desc')
  end
  def create_mensaje(sender:nil,text:nil)
    mensaje = @sala.chats.create!(
          sender:sender,
          text:text
      )
    self.add_participant_sala(sender)
    mensaje
  end
  def read(chat_id)
    mensaje = @sala.chats.find(chat_id)
    mensaje.update!(read: true)
    mensaje
  end
  def close(participant_id)
    if has_participant(participant_id)
      @sala.owner.update!(closed: true)
      @sala.update!(closed: true)
      true
    else
      false
    end
  end
  def has_participant(participant_id)
    rtn = false
    check_participants.each do |part|
     if  part.participant_id.to_s == participant_id.to_s
       rtn =  true
       break
     end
    end
    rtn
  end
  def check_participants
    @sala.chat_sala_alloweds.only(:participant_id, :participant_type) if @sala.chat_sala_alloweds
  end
  def add_participant_sala(participant)
    @sala.chat_sala_alloweds
        .find_or_create_by!(participant: participant)
  end
  def remove_participant_sala(participant)
    @sala.chat_sala_alloweds.find_by(participant: participant)&.delete
  end

end
